Loading...
Searching...
No Matches
juce::HeapBlock< ElementType, throwOnFailure > Class Template Reference

## Detailed Description

template<class ElementType, bool throwOnFailure = false>
class juce::HeapBlock< ElementType, throwOnFailure >

Very simple container class to hold a pointer to some data on the heap.

When you need to allocate some heap storage for something, always try to use this class instead of allocating the memory directly using malloc/free.

A HeapBlock<char> object can be treated in pretty much exactly the same way as an char*, but as long as you allocate it on the stack or as a class member, it's almost impossible for it to leak memory.

It also makes your code much more concise and readable than doing the same thing using direct allocations,

E.g. instead of this:

int* temp = (int*) malloc (1024 * sizeof (int));
memcpy (temp, xyz, 1024 * sizeof (int));
free (temp);
temp = (int*) calloc (2048 * sizeof (int));
temp[0] = 1234;
memcpy (foobar, temp, 2048 * sizeof (int));
free (temp);
juce::HeapBlock::malloc
void malloc(SizeType newNumElements, size_t elementSize=sizeof(ElementType))
Allocates a specified amount of memory.
Definition juce_HeapBlock.h:263
juce::HeapBlock::free
void free() noexcept
Frees any currently-allocated data.
Definition juce_HeapBlock.h:305
juce::HeapBlock::calloc
void calloc(SizeType newNumElements, const size_t elementSize=sizeof(ElementType))
Allocates a specified amount of memory and clears it.
Definition juce_HeapBlock.h:273

...you could just write this:

HeapBlock<int> temp (1024);
memcpy (temp, xyz, 1024 * sizeof (int));
temp.calloc (2048);
temp[0] = 1234;
memcpy (foobar, temp, 2048 * sizeof (int));
juce::HeapBlock::HeapBlock
friend class HeapBlock
Definition juce_HeapBlock.h:370

The class is extremely lightweight, containing only a pointer to the data, and exposes malloc/realloc/calloc/free methods that do the same jobs as their less object-oriented counterparts. Despite adding safety, you probably won't sacrifice any performance by using this in place of normal pointers.

The throwOnFailure template parameter can be set to true if you'd like the class to throw a std::bad_alloc exception when an allocation fails. If this is false, then a failed allocation will just leave the heapblock with a null pointer (assuming that the system's malloc() function doesn't throw).

See also
  Array, OwnedArray, MemoryBlock

The documentation for this class was generated from the following file:

- juce_core/memory/juce_HeapBlock.h

## Public Types

using | Type = ElementType
| This typedef can be used to get the type of the heapblock's elements.

## Public Member Functions

| HeapBlock () noexcept=default
| Creates a HeapBlock which is initially just a null pointer.
template<typename SizeType, std::enable_if_t< std::is_convertible_v< SizeType, int >, int > = 0>
| HeapBlock (SizeType numElements)
| Creates a HeapBlock containing a number of elements.
template<typename SizeType, std::enable_if_t< std::is_convertible_v< SizeType, int >, int > = 0>
| HeapBlock (SizeType numElements, bool initialiseToZero)
| Creates a HeapBlock containing a number of elements.
| ~HeapBlock ()
| Destructor.
| HeapBlock (HeapBlock &&other) noexcept
| Move constructor.
HeapBlock & | operator= (HeapBlock &&other) noexcept
| Move assignment operator.
template<class OtherElementType, bool otherThrowOnFailure, typename = AllowConversion<OtherElementType>>
| HeapBlock (HeapBlock< OtherElementType, otherThrowOnFailure > &&other) noexcept
| Converting move constructor.
template<class OtherElementType, bool otherThrowOnFailure, typename = AllowConversion<OtherElementType>>
HeapBlock & | operator= (HeapBlock< OtherElementType, otherThrowOnFailure > &&other) noexcept
| Converting move assignment operator.
| operator ElementType * () const noexcept
| Returns a raw pointer to the allocated data.
ElementType * | get () const noexcept
| Returns a raw pointer to the allocated data.
ElementType * | getData () const noexcept
| Returns a raw pointer to the allocated data.
| operator void * () const noexcept
| Returns a void pointer to the allocated data.
| operator const void * () const noexcept
| Returns a void pointer to the allocated data.
ElementType * | operator-> () const noexcept
| Lets you use indirect calls to the first element in the array.
template<typename IndexType>
ElementType & | operator[] (IndexType index) const noexcept
| Returns a reference to one of the data elements.
template<typename IndexType>
ElementType * | operator+ (IndexType index) const noexcept
| Returns a pointer to a data element at an offset from the start of the array.
bool | operator== (const ElementType *otherPointer) const noexcept
| Compares the pointer with another pointer.
bool | operator!= (const ElementType *otherPointer) const noexcept
| Compares the pointer with another pointer.
template<typename SizeType>
void | malloc (SizeType newNumElements, size_t elementSize=sizeof(ElementType))
| Allocates a specified amount of memory.
template<typename SizeType>
void | calloc (SizeType newNumElements, const size_t elementSize=sizeof(ElementType))
| Allocates a specified amount of memory and clears it.
template<typename SizeType>
void | allocate (SizeType newNumElements, bool initialiseToZero)
| Allocates a specified amount of memory and optionally clears it.
template<typename SizeType>
void | realloc (SizeType newNumElements, size_t elementSize=sizeof(ElementType))
| Re-allocates a specified amount of memory.
void | free () noexcept
| Frees any currently-allocated data.
template<bool otherBlockThrows>
void | swapWith (HeapBlock< ElementType, otherBlockThrows > &other) noexcept
| Swaps this object's data with the data of another HeapBlock.
template<typename SizeType>
void | clear (SizeType numElements) noexcept
| This fills the block with zeros, up to the number of elements specified.

## Member Typedef Documentation

## Type

template<class ElementType, bool throwOnFailure = false>

using juce::HeapBlock< ElementType, throwOnFailure >::Type = ElementType

This typedef can be used to get the type of the heapblock's elements.

## Constructors and Destructors

## HeapBlock() [1/5]

template<class ElementType, bool throwOnFailure = false>

juce::HeapBlock< ElementType, throwOnFailure >::HeapBlock | ( |  | ) |

default noexcept

Creates a HeapBlock which is initially just a null pointer.

After creation, you can resize the array using the malloc(), calloc(), or realloc() methods.

## HeapBlock() [2/5]

template<class ElementType, bool throwOnFailure = false>
template<typename SizeType, std::enable_if_t< std::is_convertible_v< SizeType, int >, int > = 0>

juce::HeapBlock< ElementType, throwOnFailure >::HeapBlock | ( | SizeType | numElements | ) |

inline explicit

Creates a HeapBlock containing a number of elements.

The contents of the block are undefined, as it will have been created by a malloc call.

If you want an array of zero values, you can use the calloc() method or the other constructor that takes an InitialisationState parameter.

## HeapBlock() [3/5]

template<class ElementType, bool throwOnFailure = false>
template<typename SizeType, std::enable_if_t< std::is_convertible_v< SizeType, int >, int > = 0>

juce::HeapBlock< ElementType, throwOnFailure >::HeapBlock | ( | SizeType | numElements,
|  | bool | initialiseToZero )

inline

Creates a HeapBlock containing a number of elements.

The initialiseToZero parameter determines whether the new memory should be cleared, or left uninitialised.

## ~HeapBlock()

template<class ElementType, bool throwOnFailure = false>

juce::HeapBlock< ElementType, throwOnFailure >::~HeapBlock | ( |  | ) |

inline

Destructor.

This will free the data, if any has been allocated.

## HeapBlock() [4/5]

template<class ElementType, bool throwOnFailure = false>

juce::HeapBlock< ElementType, throwOnFailure >::HeapBlock | ( | HeapBlock< ElementType, throwOnFailure > && | other | ) |

inline noexcept

Move constructor.

## HeapBlock() [5/5]

template<class ElementType, bool throwOnFailure = false>
template<class OtherElementType, bool otherThrowOnFailure, typename = AllowConversion<OtherElementType>>

juce::HeapBlock< ElementType, throwOnFailure >::HeapBlock | ( | HeapBlock< OtherElementType, otherThrowOnFailure > && | other | ) |

inline noexcept

Converting move constructor.

Only enabled if this is a HeapBlock<Base*> and the other object is a HeapBlock<Derived*>, where std::is_base_of_v<Base, Derived> == true.

## Member Functions

## operator=() [1/2]

template<class ElementType, bool throwOnFailure = false>

HeapBlock & juce::HeapBlock< ElementType, throwOnFailure >::operator= | ( | HeapBlock< ElementType, throwOnFailure > && | other | ) |

inline noexcept

Move assignment operator.

## operator=() [2/2]

template<class ElementType, bool throwOnFailure = false>
template<class OtherElementType, bool otherThrowOnFailure, typename = AllowConversion<OtherElementType>>

HeapBlock & juce::HeapBlock< ElementType, throwOnFailure >::operator= | ( | HeapBlock< OtherElementType, otherThrowOnFailure > && | other | ) |

inline noexcept

Converting move assignment operator.

Only enabled if this is a HeapBlock<Base*> and the other object is a HeapBlock<Derived*>, where std::is_base_of_v<Base, Derived> == true.

## operator ElementType *()

template<class ElementType, bool throwOnFailure = false>

juce::HeapBlock< ElementType, throwOnFailure >::operator ElementType * | ( |  | ) | const

inline noexcept

Returns a raw pointer to the allocated data.

This may be a null pointer if the data hasn't yet been allocated, or if it has been freed by calling the free() method.

## get()

template<class ElementType, bool throwOnFailure = false>

ElementType * juce::HeapBlock< ElementType, throwOnFailure >::get | ( |  | ) | const

inline noexcept

Returns a raw pointer to the allocated data.

This may be a null pointer if the data hasn't yet been allocated, or if it has been freed by calling the free() method.

Referenced by juce::AudioBuffer< float >::setSize().

## getData()

template<class ElementType, bool throwOnFailure = false>

ElementType * juce::HeapBlock< ElementType, throwOnFailure >::getData | ( |  | ) | const

inline noexcept

Returns a raw pointer to the allocated data.

This may be a null pointer if the data hasn't yet been allocated, or if it has been freed by calling the free() method.

## operator void *()

template<class ElementType, bool throwOnFailure = false>

juce::HeapBlock< ElementType, throwOnFailure >::operator void * | ( |  | ) | const

inline noexcept

Returns a void pointer to the allocated data.

This may be a null pointer if the data hasn't yet been allocated, or if it has been freed by calling the free() method.

## operator const void *()

template<class ElementType, bool throwOnFailure = false>

juce::HeapBlock< ElementType, throwOnFailure >::operator const void * | ( |  | ) | const

inline noexcept

Returns a void pointer to the allocated data.

This may be a null pointer if the data hasn't yet been allocated, or if it has been freed by calling the free() method.

## operator->()

template<class ElementType, bool throwOnFailure = false>

ElementType * juce::HeapBlock< ElementType, throwOnFailure >::operator-> | ( |  | ) | const

inline noexcept

Lets you use indirect calls to the first element in the array.

Obviously this will cause problems if the array hasn't been initialised, because it'll be referencing a null pointer.

## operator[]()

template<class ElementType, bool throwOnFailure = false>
template<typename IndexType>

ElementType & juce::HeapBlock< ElementType, throwOnFailure >::operator[] | ( | IndexType | index | ) | const

inline noexcept

Returns a reference to one of the data elements.

Obviously there's no bounds-checking here, as this object is just a dumb pointer and has no idea of the size it currently has allocated.

## operator+()

template<class ElementType, bool throwOnFailure = false>
template<typename IndexType>

ElementType * juce::HeapBlock< ElementType, throwOnFailure >::operator+ | ( | IndexType | index | ) | const

inline noexcept

Returns a pointer to a data element at an offset from the start of the array.

This is the same as doing pointer arithmetic on the raw pointer itself.

## operator==()

template<class ElementType, bool throwOnFailure = false>

bool juce::HeapBlock< ElementType, throwOnFailure >::operator== | ( | const ElementType * | otherPointer | ) | const

inline noexcept

Compares the pointer with another pointer.

This can be handy for checking whether this is a null pointer.

## operator!=()

template<class ElementType, bool throwOnFailure = false>

bool juce::HeapBlock< ElementType, throwOnFailure >::operator!= | ( | const ElementType * | otherPointer | ) | const

inline noexcept

Compares the pointer with another pointer.

This can be handy for checking whether this is a null pointer.

## malloc()

template<class ElementType, bool throwOnFailure = false>
template<typename SizeType>

void juce::HeapBlock< ElementType, throwOnFailure >::malloc | ( | SizeType | newNumElements,
|  | size_t | elementSize = sizeof (ElementType) )

inline

Allocates a specified amount of memory.

This uses the normal malloc to allocate an amount of memory for this object. Any previously allocated memory will be freed by this method.

The number of bytes allocated will be (newNumElements * elementSize). Normally you wouldn't need to specify the second parameter, but it can be handy if you need to allocate a size in bytes rather than in terms of the number of elements.

The data that is allocated will be freed when this object is deleted, or when you call free() or any of the allocation methods.

## calloc()

template<class ElementType, bool throwOnFailure = false>
template<typename SizeType>

void juce::HeapBlock< ElementType, throwOnFailure >::calloc | ( | SizeType | newNumElements,
|  | const size_t | elementSize = sizeof (ElementType) )

inline

Allocates a specified amount of memory and clears it.

This does the same job as the malloc() method, but clears the memory that it allocates.

## allocate()

template<class ElementType, bool throwOnFailure = false>
template<typename SizeType>

void juce::HeapBlock< ElementType, throwOnFailure >::allocate | ( | SizeType | newNumElements,
|  | bool | initialiseToZero )

inline

Allocates a specified amount of memory and optionally clears it.

This does the same job as either malloc() or calloc(), depending on the initialiseToZero parameter.

Referenced by juce::AudioBuffer< float >::setSize().

## realloc()

template<class ElementType, bool throwOnFailure = false>
template<typename SizeType>

void juce::HeapBlock< ElementType, throwOnFailure >::realloc | ( | SizeType | newNumElements,
|  | size_t | elementSize = sizeof (ElementType) )

inline

Re-allocates a specified amount of memory.

The semantics of this method are the same as malloc() and calloc(), but it uses realloc() to keep as much of the existing data as possible.

## free()

template<class ElementType, bool throwOnFailure = false>

void juce::HeapBlock< ElementType, throwOnFailure >::free | ( |  | ) |

inline noexcept

Frees any currently-allocated data.

This will free the data and reset this object to be a null pointer.

Referenced by juce::HeapBlock< char, true >::operator=().

## swapWith()

template<class ElementType, bool throwOnFailure = false>
template<bool otherBlockThrows>

void juce::HeapBlock< ElementType, throwOnFailure >::swapWith | ( | HeapBlock< ElementType, otherBlockThrows > & | other | ) |

inline noexcept

Swaps this object's data with the data of another HeapBlock.

The two objects simply exchange their data pointers.

## clear()

template<class ElementType, bool throwOnFailure = false>
template<typename SizeType>

void juce::HeapBlock< ElementType, throwOnFailure >::clear | ( | SizeType | numElements | ) |

inline noexcept

This fills the block with zeros, up to the number of elements specified.

Since the block has no way of knowing its own size, you must make sure that the number of elements you specify doesn't exceed the allocated size.

### Purchase

Get JUCE

### Discover

What's New in JUCE Features

### Learn

Documentaion Tutorials Made with JUCE Resources

### Support

JUCE Forum Newsletter Archive

### About

Contact Us JUCE Legal JUCE Licensing FAQ

### Events

Audio Developer Conference
© Raw Material Software Limited